JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
ARADocument Class Reference
juce_audio_processors » utilities

Base class representing an ARA document. More...

`#include <juce_ARAModelObjects.h>`

Inheritance diagram for ARADocument:

## Public Types
using | PropertiesPtr = ARA::PlugIn::PropertiesPtr<ARA::ARADocumentProperties>
using | Listener = ARADocumentListener

## Public Member Functions
template<typename AudioSource_t = ARAAudioSource>
const std::vector< AudioSource_t * > & | getAudioSources () const noexcept
| Returns the result of ARA::PlugIn::Document::getAudioSources() with the pointers within cast to ARAAudioSource*.
template<typename MusicalContext_t = ARAMusicalContext>
const std::vector< MusicalContext_t * > & | getMusicalContexts () const noexcept
| Returns the result of ARA::PlugIn::Document::getMusicalContexts() with the pointers within cast to ARAMusicalContext*.
template<typename RegionSequence_t = ARARegionSequence>
const std::vector< RegionSequence_t * > & | getRegionSequences () const noexcept
| Returns the result of ARA::PlugIn::Document::getRegionSequences() with the pointers within cast to ARARegionSequence*.
size_t | getNumChildren () const noexcept override
| Returns the number of ARA model objects aggregated by this object.
ARAObject * | getChild (size_t index) override
| Returns the child object associated with the given index.
ARAObject * | getParent () override
| Returns the ARA model object that aggregates this object.
void | visit (ARAObjectVisitor &visitor) override
| Allows the retrieval of the concrete type of a model object.
Public Member Functions inherited from ARAListenableModelClass< ARADocumentListener >
| ARAListenableModelClass ()=default
| Constructor.
virtual | ~ARAListenableModelClass ()=default
| Destructor.
void | addListener (ARADocumentListener *l)
| Subscribe `l` to notified by changes to the object.
void | removeListener (ARADocumentListener *l)
| Unsubscribe `l` from object notifications.
void | notifyListeners (Callback &&callback)
| Call the provided callback for each of the added listeners.
Public Member Functions inherited from ARAObject
virtual | ~ARAObject ()=default
| Destructor.
template<typename Fn >
void | traverse (Fn &&fn)
| Implements a depth first traversal of the ARA model graph starting from the current object, and visiting its children recursively.

## Detailed Description

Base class representing an ARA document.

## Member Typedef Documentation

## ◆ PropertiesPtr

using ARADocument::PropertiesPtr = ARA::PlugIn::PropertiesPtr<ARA::ARADocumentProperties>

## ◆ Listener

using ARADocument::Listener = ARADocumentListener

## Member Function Documentation

## ◆ getAudioSources()

template<typename AudioSource_t = ARAAudioSource>

const std::vector< AudioSource_t * > & ARADocument::getAudioSources | ( |  | ) | const
| noexcept

Returns the result of ARA::PlugIn::Document::getAudioSources() with the pointers within cast to ARAAudioSource*.

If you have overridden ARADocumentControllerSpecialisation::doCreateAudioSource(), then you can use the template parameter to cast the pointers to your subclass of ARAAudioSource.

## ◆ getMusicalContexts()

template<typename MusicalContext_t = ARAMusicalContext>

const std::vector< MusicalContext_t * > & ARADocument::getMusicalContexts | ( |  | ) | const
| noexcept

Returns the result of ARA::PlugIn::Document::getMusicalContexts() with the pointers within cast to ARAMusicalContext*.

If you have overridden ARADocumentControllerSpecialisation::doCreateMusicalContext(), then you can use the template parameter to cast the pointers to your subclass of ARAMusicalContext.

## ◆ getRegionSequences()

template<typename RegionSequence_t = ARARegionSequence>

const std::vector< RegionSequence_t * > & ARADocument::getRegionSequences | ( |  | ) | const
| noexcept

Returns the result of ARA::PlugIn::Document::getRegionSequences() with the pointers within cast to ARARegionSequence*.

If you have overridden ARADocumentControllerSpecialisation::doCreateRegionSequence(), then you can use the template parameter to cast the pointers to your subclass of ARARegionSequence.

## ◆ getNumChildren()

size_t ARADocument::getNumChildren | ( |  | ) | const
| override virtual noexcept

Returns the number of ARA model objects aggregated by this object.

Objects that are merely referred to, but not aggregated by the current object are not included in this count, e.g. a referenced RegionSequence does not count as a child of the referring PlaybackRegion.

See the ARA documentation's ARA Model Graph Overview for more details.

Implements ARAObject.

## ◆ getChild()

ARAObject * ARADocument::getChild | ( | size_t | index | ) |
| override virtual

Returns the child object associated with the given index.

The index should be smaller than the value returned by getNumChildren().

Note that the index of a particular object may change when the ARA model graph is edited.

Implements ARAObject.

## ◆ getParent()

ARAObject * ARADocument::getParent | ( |  | ) |
| override virtual

Returns the ARA model object that aggregates this object.

Returns nullptr for the ARADocument root object.

Implements ARAObject.

## ◆ visit()

void ARADocument::visit | ( | ARAObjectVisitor & | visitor | ) |
| override virtual

Allows the retrieval of the concrete type of a model object.

To use this, create a new class derived from ARAObjectVisitor and override its functions depending on which concrete types you are interested in.

Calling this function inside the function passed to ARAObject::traverse() allows you to map the entire ARA model graph.

Implements ARAObject.

References ARAObjectVisitor::visitDocument().

The documentation for this class was generated from the following file:

- juce_ARAModelObjects.h